Package: groovy.lang

## [Java] Class DelegatingMetaClass

- groovy.lang.DelegatingMetaClass

- All Implemented Interfaces and Traits:
    GroovyObject, MetaClass, MutableMetaClass

      public class DelegatingMetaClass
      extends Object
      implements GroovyObject, MetaClass, MutableMetaClass

  MetaClass implementation that forwards all operations to another meta class.

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `protected MetaClass` | `delegate` | Wrapped meta class that receives delegated operations.

  - ### Constructor Summary

    Constructors
    Constructor and description
    `DelegatingMetaClass(MetaClass delegate)` Creates a delegating meta class for the supplied adaptee.
    `DelegatingMetaClass(Class theClass)` Creates a delegating meta class for the current meta class of the supplied type.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public void` | `addMetaBeanProperty(MetaBeanProperty metaBeanProperty)` Adds a new MetaBeanProperty to the MetaClass Parameters: `metaBeanProperty` - The MetaBeanProperty instance
    `` | `public void` | `addMetaMethod(MetaMethod metaMethod)` Adds a new MetaMethod to the MetaClass Parameters: `metaMethod` - The MetaMethod to add
    `` | `public void` | `addNewInstanceMethod(Method method)` adds a new instance method to this MetaClass. Instance methods are able to overwrite the original methods of the class. Calling this method should not be done after initialise was called. Parameters: `method` - the method to be added
    `` | `public void` | `addNewStaticMethod(Method method)` adds a new static method to this MetaClass. This is only possible as long as initialise was not called. Parameters: `method` - the method to be added
    `` | `public boolean` | `equals(Object obj)` {@inheritDoc}
    `` | `public MetaClass` | `getAdaptee()` Returns the wrapped meta class.
    `` | `public Object` | `getAttribute(Object object, String attribute)` Retrieves an attribute of an instance of the class returned by the getTheClass() method. What this means is largely down to the MetaClass implementation, however the default case would result in attempt to read a field of the instance. See Also: MetaClassImpl Parameters: `object` - An instance of the class returned by the getTheClass() method `attribute` - The name of the attribute to retrieve the value for Returns: The attribute value
    `` | `public Object` | `getAttribute(Class sender, Object receiver, String messageName, boolean useSuper)` Retrieves the value of an attribute (field). This method is to support the Groovy runtime and not for general client API usage. Parameters: `sender` - The class of the object that requested the attribute `receiver` - The instance `messageName` - The name of the attribute `useSuper` - Whether to look-up on the super class or not Returns: The attribute value
    `` | `public ClassNode` | `getClassNode()` Obtains a reference to the original AST for the MetaClass if it is available at runtime Returns: The original AST or null if it cannot be returned
    `` | `public MetaClass` | `getMetaClass()` Returns the metaclass for a given class. Returns: the metaClass of this instance
    `` | `public MetaMethod` | `getMetaMethod(String name, Object[] args)` Retrieves an instance MetaMethod for the given name and argument values, using the types of the argument values to establish the chosen MetaMethod Parameters: `name` - The name of the MetaMethod `args` - Array containing - 1) the argument values (using which their types are then inferred), or 2) the corresponding argument types Returns: A MetaMethod or null if it doesn't exist
    `` | `public List<MetaMethod>` | `getMetaMethods()` Retrieves a list of MetaMethods held by this class. This list includes MetaMethods added by groovy.lang.ExpandoMetaClass. Returns: A list of MetaMethods
    `` | `public MetaProperty` | `getMetaProperty(String name)` Returns a MetaProperty for the given name or null if it doesn't exist Parameters: `name` - The name of the MetaProperty Returns: A MetaProperty or null
    `` | `public List<MetaMethod>` | `getMethods()` Retrieves a list of MetaMethods held by the class. This list does not include MetaMethods added by groovy.lang.ExpandoMetaClass. Returns: A list of MetaMethods
    `` | `public List<MetaProperty>` | `getProperties()` Retrieves a list of MetaProperty instances that the MetaClass has See Also: MetaProperty Returns: A list of MetaProperty instances
    `` | `public Object` | `getProperty(Object object, String property)` Retrieves a property of an instance of the class returned by the getTheClass() method. What this means is largely down to the MetaClass implementation, however the default case would result in an attempt to invoke a JavaBean getter, or if no such getter exists a public field of the instance. See Also: MetaClassImpl Parameters: `object` - An instance of the class returned by the getTheClass() method `property` - The name of the property to retrieve the value for Returns: The properties value
    `` | `public Object` | `getProperty(Class sender, Object receiver, String messageName, boolean useSuper, boolean fromInsideClass)` Retrieves a property on the given receiver for the specified arguments. The sender is the class that is requesting the property from the object. The MetaClass will attempt to establish the method to invoke based on the name and arguments provided. The isCallToSuper and fromInsideClass help the Groovy runtime perform optimisations on the call to go directly to the super class if necessary Parameters: `sender` - The java.lang.Class instance that requested the property `receiver` - The Object which the property is being retrieved from `property` - The name of the property `isCallToSuper` - Whether the call is to a super class property `fromInsideClass` - ?? Returns: The property's value.
    `` | `public Object` | `getProperty(String property)` Retrieves a property value. Parameters: `propertyName` - the name of the property of interest Returns: the given property
    `` | `public MetaMethod` | `getStaticMetaMethod(String name, Object[] args)` Retrieves a static MetaMethod for the given name and argument values, using the types of the arguments to establish the chosen MetaMethod Parameters: `name` - The name of the MetaMethod `args` - The argument types Returns: A MetaMethod or null if it doesn't exist
    `` | `public MetaMethod` | `getStaticMetaMethod(String name, Class[] argTypes)` Finds a static meta method using explicit parameter types.
    `` | `public Class` | `getTheClass()` Retrieves that Java Class that the attached Meta behaviours apply to Returns: The java.lang.Class instance
    `` | `public MetaProperty` | `hasProperty(Object obj, String name)` Returns true of the implementing MetaClass has a property of the given name Note that this method will only return true for realised properties and does not take into account implementation of getProperty or propertyMissing Parameters: `obj` - The object to inspect `name` - The name of the property Returns: The MetaProperty or null if it doesn't exist
    `` | `public int` | `hashCode()` {@inheritDoc}
    `` | `public void` | `initialize()` Complete the initialisation process. After this method is called no methods should be added to the metaclass. Invocation of methods or access to fields/properties is forbidden unless this method is called. This method should contain any initialisation code, taking a longer time to complete. An example is the creation of the Reflector. It is suggested to synchronize this method.
    `` | `public Object` | `invokeConstructor(Object[] arguments)` Invokes a constructor for the given arguments. The MetaClass will attempt to pick the best argument which matches the types of the objects passed within the arguments array Parameters: `arguments` - The arguments to the constructor Returns: An instance of the java.lang.Class that this MetaObjectProtocol object applies to
    `` | `public Object` | `invokeMethod(Object object, String methodName, Object arguments)` Invokes a method on the given Object with the given name and arguments. The MetaClass will attempt to pick the best method for the given name and arguments. If a method cannot be invoked a MissingMethodException will be thrown. See Also: MissingMethodException Parameters: `object` - The instance which the method is invoked on `methodName` - The name of the method `arguments` - The arguments to the method Returns: The return value of the method which is null if the return type is void
    `` | `public Object` | `invokeMethod(Object object, String methodName, Object[] arguments)` Invokes a method on the given Object with the given name and arguments. The MetaClass will attempt to pick the best method for the given name and arguments. If a method cannot be invoked a MissingMethodException will be thrown. See Also: MissingMethodException Parameters: `object` - The instance which the method is invoked on `methodName` - The name of the method `arguments` - The arguments to the method Returns: The return value of the method which is null if the return type is void
    `` | `public Object` | `invokeMethod(Class sender, Object receiver, String methodName, Object[] arguments, boolean isCallToSuper, boolean fromInsideClass)` Invokes a method on the given receiver for the specified arguments. The sender is the class that invoked the method on the object. The MetaClass will attempt to establish the method to invoke based on the name and arguments provided. The isCallToSuper and fromInsideClass help the Groovy runtime perform optimisations on the call to go directly to the super class if necessary Parameters: `sender` - The java.lang.Class instance that invoked the method `receiver` - The object which the method was invoked on `methodName` - The name of the method `arguments` - The arguments to the method `isCallToSuper` - Whether the method is a call to a super class method `fromInsideClass` - Whether the call was invoked from the inside or the outside of the class Returns: The method's return value.
    `` | `public Object` | `invokeMethod(String name, Object args)` Invokes the given method. Parameters: `name` - the name of the method to call `args` - the arguments to use for the method call Returns: the result of invoking the method
    `` | `public Object` | `invokeMissingMethod(Object instance, String methodName, Object[] arguments)` Attempts to invoke the methodMissing method otherwise throws a MissingMethodException See Also: MissingMethodException Parameters: `instance` - The instance to invoke methodMissing on `methodName` - The name of the method `arguments` - The arguments to the method Returns: The results of methodMissing or throws MissingMethodException
    `` | `public Object` | `invokeMissingProperty(Object instance, String propertyName, Object optionalValue, boolean isGetter)` Invokes the propertyMissing method otherwise throws a MissingPropertyException Parameters: `instance` - The instance of the class `propertyName` - The name of the property `optionalValue` - The value of the property which could be null in the case of a getter `isGetter` - Whether the missing property event was the result of a getter or a setter Returns: The result of the propertyMissing method or throws MissingPropertyException
    `` | `public Object` | `invokeStaticMethod(Object object, String methodName, Object[] arguments)` Invokes a static method on the given Object with the given name and arguments. The Object can either be an instance of the class that this MetaObjectProtocol instance applies to or the java.lang.Class instance itself. If a method cannot be invoked a MissingMethodException is will be thrown See Also: MissingMethodException Parameters: `object` - An instance of the class returned by the getTheClass() method or the class itself `methodName` - The name of the method `arguments` - The arguments to the method Returns: The return value of the method which is null if the return type is void
    `` | `public boolean` | `isGroovyObject()` Indicates whether the wrapped type implements GroovyObject.
    `` | `public boolean` | `isModified()` Return whether the MetaClass has been modified or not Returns: True if it has
    `` | `public MetaMethod` | `pickMethod(String methodName, Class[] arguments)` @deprecated
    `` | `public List<MetaMethod>` | `respondsTo(Object obj, String name, Object[] argTypes)` Returns an object satisfying Groovy truth if the implementing MetaClass responds to a method with the given name and arguments types. Note that this method's return value is based on realised methods and does not take into account objects or classes that implement invokeMethod or methodMissing This method is "safe" in that it will always return a value and never throw an exception Parameters: `obj` - The object to inspect `name` - The name of the method of interest `argTypes` - The argument types to match against Returns: A List of MetaMethods matching the argument types which will be empty if no matching methods exist
    `` | `public List<MetaMethod>` | `respondsTo(Object obj, String name)` Returns an object satisfying Groovy truth if the implementing MetaClass responds to a method with the given name regardless of arguments. In other words this method will return for foo() and foo(String). Note that this method's return value is based on realised methods and does not take into account objects or classes that implement invokeMethod or methodMissing This method is "safe" in that it will always return a value and never throw an exception Parameters: `obj` - The object to inspect `name` - The name of the method of interest Returns: A List of MetaMethods which will be empty if no methods with the given name exist
    `` | `public int` | `selectConstructorAndTransformArguments(int numberOfConstructors, Object[] arguments)` Internal method to support Groovy runtime. Not for client usage. Parameters: `numberOfConstructors` - The number of constructors `arguments` - The arguments Returns: selected index
    `` | `public void` | `setAdaptee(MetaClass adaptee)` Replaces the wrapped meta class.
    `` | `public void` | `setAttribute(Object object, String attribute, Object newValue)` Sets an attribute of an instance of the class returned by the getTheClass() method. What this means is largely down to the MetaClass implementation, however the default case would result in an attempt to set a field of the instance. See Also: MetaClassImpl Parameters: `object` - An instance of the class returned by the getTheClass() method `attribute` - The name of the attribute to set `newValue` - The new value of the attribute
    `` | `public void` | `setAttribute(Class sender, Object receiver, String messageName, Object messageValue, boolean useSuper, boolean fromInsideClass)` Sets the value of an attribute (field). This method is to support the Groovy runtime and not for general client API usage. Parameters: `sender` - The class of the object that requested the attribute `receiver` - The instance `messageName` - The name of the attribute `messageValue` - The value of the attribute `useSuper` - Whether to look-up on the super class or not `fromInsideClass` - Whether the call happened from the inside or the outside of a class
    `` | `public void` | `setMetaClass(MetaClass metaClass)` Allows the MetaClass to be replaced with a derived implementation. Parameters: `metaClass` - the new metaclass
    `` | `public void` | `setProperty(Object object, String property, Object newValue)` Sets a property of an instance of the class returned by the getTheClass() method. What this means is largely down to the MetaClass implementation, however the default case would result in an attempt to invoke a JavaBean setter, or if no such setter exists to set a public field of the instance. See Also: MetaClassImpl Parameters: `object` - An instance of the class returned by the getTheClass() method `property` - The name of the property to set `newValue` - The new value of the property
    `` | `public void` | `setProperty(Class sender, Object receiver, String messageName, Object messageValue, boolean useSuper, boolean fromInsideClass)` Sets a property on the given receiver for the specified arguments. The sender is the class that is setting the property from the object. The MetaClass will attempt to establish the method to invoke based on the name and arguments provided. The isCallToSuper and fromInsideClass help the Groovy runtime perform optimisations on the call to go directly to the super class if necessary Parameters: `sender` - The java.lang.Class instance that is mutating the property `receiver` - The Object which the property is being set on `property` - The name of the property `value` - The new value of the property to set `isCallToSuper` - Whether the call is to a super class property `fromInsideClass` - Whether the call was invoked from the inside or the outside of the class
    `` | `public void` | `setProperty(String property, Object newValue)` Sets the given property to the new value. Parameters: `propertyName` - the name of the property of interest `newValue` - the new value for the property
    `` | `public String` | `toString()` {@inheritDoc}

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### protected MetaClass delegate

      Wrapped meta class that receives delegated operations.

  - ### Constructor Detail

    - #### public DelegatingMetaClass(MetaClass delegate)

      Creates a delegating meta class for the supplied adaptee.

      Parameters:
        `delegate` - the meta class to delegate to

    - #### public DelegatingMetaClass(Class theClass)

      Creates a delegating meta class for the current meta class of the supplied type.

      Parameters:
        `theClass` - the Groovy type whose meta class should be wrapped

  - ### Method Detail

    - #### public void addMetaBeanProperty(MetaBeanProperty metaBeanProperty)

      Adds a new MetaBeanProperty to the MetaClass

      Parameters:
        `metaBeanProperty` - The MetaBeanProperty instance

    - #### public void addMetaMethod(MetaMethod metaMethod)

      Adds a new MetaMethod to the MetaClass

      Parameters:
        `metaMethod` - The MetaMethod to add

    - #### public void addNewInstanceMethod(Method method)

      adds a new instance method to this MetaClass. Instance methods are able to overwrite the original methods of the class. Calling this method should not be done after initialise was called.

      Parameters:
        `method` - the method to be added

    - #### public void addNewStaticMethod(Method method)

      adds a new static method to this MetaClass. This is only possible as long as initialise was not called.

      Parameters:
        `method` - the method to be added

    - #### public boolean equals(Object obj)

      {@inheritDoc}

    - #### public MetaClass getAdaptee()

      Returns the wrapped meta class.

      Returns:
        the current adaptee

    - #### public Object getAttribute(Object object, String attribute)

      Retrieves an attribute of an instance of the class returned by the getTheClass() method.

      What this means is largely down to the MetaClass implementation, however the default case would result in attempt to read a field of the instance.

      See Also:
        MetaClassImpl
      Parameters:
        `object` - An instance of the class returned by the getTheClass() method
        `attribute` - The name of the attribute to retrieve the value for
      Returns:
        The attribute value

    - #### public Object getAttribute(Class sender, Object receiver, String messageName, boolean useSuper)

      Retrieves the value of an attribute (field). This method is to support the Groovy runtime and not for general client API usage.

      Parameters:
        `sender` - The class of the object that requested the attribute
        `receiver` - The instance
        `messageName` - The name of the attribute
        `useSuper` - Whether to look-up on the super class or not
      Returns:
        The attribute value

    - #### public ClassNode getClassNode()

      Obtains a reference to the original AST for the MetaClass if it is available at runtime

      Returns:
        The original AST or null if it cannot be returned

    - #### public MetaClass getMetaClass()

      Returns the metaclass for a given class.

      Returns:
        the metaClass of this instance

    - #### public MetaMethod getMetaMethod(String name, Object[] args)

      Retrieves an instance MetaMethod for the given name and argument values, using the types of the argument values to establish the chosen MetaMethod

      Parameters:
        `name` - The name of the MetaMethod
        `args` - Array containing - 1) the argument values (using which their types are then inferred), or 2) the corresponding argument types
      Returns:
        A MetaMethod or null if it doesn't exist

    - #### public List<MetaMethod> getMetaMethods()

      Retrieves a list of MetaMethods held by this class. This list includes MetaMethods added by groovy.lang.ExpandoMetaClass.

      Returns:
        A list of MetaMethods

    - #### public MetaProperty getMetaProperty(String name)

      Returns a MetaProperty for the given name or null if it doesn't exist

      Parameters:
        `name` - The name of the MetaProperty
      Returns:
        A MetaProperty or null

    - #### public List<MetaMethod> getMethods()

      Retrieves a list of MetaMethods held by the class. This list does not include MetaMethods added by groovy.lang.ExpandoMetaClass.

      Returns:
        A list of MetaMethods

    - #### public List<MetaProperty> getProperties()

      Retrieves a list of MetaProperty instances that the MetaClass has

      See Also:
        MetaProperty
      Returns:
        A list of MetaProperty instances

    - #### public Object getProperty(Object object, String property)

      Retrieves a property of an instance of the class returned by the getTheClass() method.

      What this means is largely down to the MetaClass implementation, however the default case would result in an attempt to invoke a JavaBean getter, or if no such getter exists a public field of the instance.

      See Also:
        MetaClassImpl
      Parameters:
        `object` - An instance of the class returned by the getTheClass() method
        `property` - The name of the property to retrieve the value for
      Returns:
        The properties value

    - #### public Object getProperty(Class sender, Object receiver, String messageName, boolean useSuper, boolean fromInsideClass)

      Retrieves a property on the given receiver for the specified arguments. The sender is the class that is requesting the property from the object. The MetaClass will attempt to establish the method to invoke based on the name and arguments provided.

      The isCallToSuper and fromInsideClass help the Groovy runtime perform optimisations on the call to go directly to the super class if necessary

      Parameters:
        `sender` - The java.lang.Class instance that requested the property
        `receiver` - The Object which the property is being retrieved from
        `property` - The name of the property
        `isCallToSuper` - Whether the call is to a super class property
        `fromInsideClass` - ??
      Returns:
        The property's value.

    - #### public Object getProperty(String property)

      Retrieves a property value.

      Parameters:
        `propertyName` - the name of the property of interest
      Returns:
        the given property

    - #### public MetaMethod getStaticMetaMethod(String name, Object[] args)

      Retrieves a static MetaMethod for the given name and argument values, using the types of the arguments to establish the chosen MetaMethod

      Parameters:
        `name` - The name of the MetaMethod
        `args` - The argument types
      Returns:
        A MetaMethod or null if it doesn't exist

    - #### public MetaMethod getStaticMetaMethod(String name, Class[] argTypes)

      Finds a static meta method using explicit parameter types.

      Parameters:
        `name` - the method name
        `argTypes` - the parameter types to match
      Returns:
        the matching static meta method, or `null` if none matches

    - #### public Class getTheClass()

      Retrieves that Java Class that the attached Meta behaviours apply to

      Returns:
        The java.lang.Class instance

    - #### public MetaProperty hasProperty(Object obj, String name)

      Returns true of the implementing MetaClass has a property of the given name

      Note that this method will only return true for realised properties and does not take into account implementation of getProperty or propertyMissing

      Parameters:
        `obj` - The object to inspect
        `name` - The name of the property
      Returns:
        The MetaProperty or null if it doesn't exist

    - #### public int hashCode()

      {@inheritDoc}

    - #### public void initialize()

      Complete the initialisation process. After this method is called no methods should be added to the metaclass. Invocation of methods or access to fields/properties is forbidden unless this method is called. This method should contain any initialisation code, taking a longer time to complete. An example is the creation of the Reflector. It is suggested to synchronize this method.

    - #### public Object invokeConstructor(Object[] arguments)

      Invokes a constructor for the given arguments. The MetaClass will attempt to pick the best argument which matches the types of the objects passed within the arguments array

      Parameters:
        `arguments` - The arguments to the constructor
      Returns:
        An instance of the java.lang.Class that this MetaObjectProtocol object applies to

    - #### public Object invokeMethod(Object object, String methodName, Object arguments)

      Invokes a method on the given Object with the given name and arguments. The MetaClass will attempt to pick the best method for the given name and arguments. If a method cannot be invoked a MissingMethodException will be thrown.

      See Also:
        MissingMethodException
      Parameters:
        `object` - The instance which the method is invoked on
        `methodName` - The name of the method
        `arguments` - The arguments to the method
      Returns:
        The return value of the method which is null if the return type is void

    - #### public Object invokeMethod(Object object, String methodName, Object[] arguments)

      Invokes a method on the given Object with the given name and arguments. The MetaClass will attempt to pick the best method for the given name and arguments. If a method cannot be invoked a MissingMethodException will be thrown.

      See Also:
        MissingMethodException
      Parameters:
        `object` - The instance which the method is invoked on
        `methodName` - The name of the method
        `arguments` - The arguments to the method
      Returns:
        The return value of the method which is null if the return type is void

    - #### public Object invokeMethod(Class sender, Object receiver, String methodName, Object[] arguments, boolean isCallToSuper, boolean fromInsideClass)

      Invokes a method on the given receiver for the specified arguments. The sender is the class that invoked the method on the object. The MetaClass will attempt to establish the method to invoke based on the name and arguments provided.

      The isCallToSuper and fromInsideClass help the Groovy runtime perform optimisations on the call to go directly to the super class if necessary

      Parameters:
        `sender` - The java.lang.Class instance that invoked the method
        `receiver` - The object which the method was invoked on
        `methodName` - The name of the method
        `arguments` - The arguments to the method
        `isCallToSuper` - Whether the method is a call to a super class method
        `fromInsideClass` - Whether the call was invoked from the inside or the outside of the class
      Returns:
        The method's return value.

    - #### public Object invokeMethod(String name, Object args)

      Invokes the given method.

      Parameters:
        `name` - the name of the method to call
        `args` - the arguments to use for the method call
      Returns:
        the result of invoking the method

    - #### public Object invokeMissingMethod(Object instance, String methodName, Object[] arguments)

      Attempts to invoke the methodMissing method otherwise throws a MissingMethodException

      See Also:
        MissingMethodException
      Parameters:
        `instance` - The instance to invoke methodMissing on
        `methodName` - The name of the method
        `arguments` - The arguments to the method
      Returns:
        The results of methodMissing or throws MissingMethodException

    - #### public Object invokeMissingProperty(Object instance, String propertyName, Object optionalValue, boolean isGetter)

      Invokes the propertyMissing method otherwise throws a MissingPropertyException

      Parameters:
        `instance` - The instance of the class
        `propertyName` - The name of the property
        `optionalValue` - The value of the property which could be null in the case of a getter
        `isGetter` - Whether the missing property event was the result of a getter or a setter
      Returns:
        The result of the propertyMissing method or throws MissingPropertyException

    - #### public Object invokeStaticMethod(Object object, String methodName, Object[] arguments)

      Invokes a static method on the given Object with the given name and arguments.

      The Object can either be an instance of the class that this MetaObjectProtocol instance applies to or the java.lang.Class instance itself. If a method cannot be invoked a MissingMethodException is will be thrown

      See Also:
        MissingMethodException
      Parameters:
        `object` - An instance of the class returned by the getTheClass() method or the class itself
        `methodName` - The name of the method
        `arguments` - The arguments to the method
      Returns:
        The return value of the method which is null if the return type is void

    - #### public boolean isGroovyObject()

      Indicates whether the wrapped type implements GroovyObject.

      Returns:
        `true` if the adaptee represents a Groovy object type

    - #### public boolean isModified()

      Return whether the MetaClass has been modified or not

      Returns:
        True if it has

    - #### @Deprecated
      public MetaMethod pickMethod(String methodName, Class[] arguments)

      deprecated:

    - #### public List<MetaMethod> respondsTo(Object obj, String name, Object[] argTypes)

      Returns an object satisfying Groovy truth if the implementing MetaClass responds to a method with the given name and arguments types.

      Note that this method's return value is based on realised methods and does not take into account objects or classes that implement invokeMethod or methodMissing

      This method is "safe" in that it will always return a value and never throw an exception

      Parameters:
        `obj` - The object to inspect
        `name` - The name of the method of interest
        `argTypes` - The argument types to match against
      Returns:
        A List of MetaMethods matching the argument types which will be empty if no matching methods exist

    - #### public List<MetaMethod> respondsTo(Object obj, String name)

      Returns an object satisfying Groovy truth if the implementing MetaClass responds to a method with the given name regardless of arguments. In other words this method will return for foo() and foo(String).

      Note that this method's return value is based on realised methods and does not take into account objects or classes that implement invokeMethod or methodMissing

      This method is "safe" in that it will always return a value and never throw an exception

      Parameters:
        `obj` - The object to inspect
        `name` - The name of the method of interest
      Returns:
        A List of MetaMethods which will be empty if no methods with the given name exist

    - #### public int selectConstructorAndTransformArguments(int numberOfConstructors, Object[] arguments)

      Internal method to support Groovy runtime. Not for client usage.

      Parameters:
        `numberOfConstructors` - The number of constructors
        `arguments` - The arguments
      Returns:
        selected index

    - #### public void setAdaptee(MetaClass adaptee)

      Replaces the wrapped meta class.

      Parameters:
        `adaptee` - the new meta class to delegate to

    - #### public void setAttribute(Object object, String attribute, Object newValue)

      Sets an attribute of an instance of the class returned by the getTheClass() method.

      What this means is largely down to the MetaClass implementation, however the default case would result in an attempt to set a field of the instance.

      See Also:
        MetaClassImpl
      Parameters:
        `object` - An instance of the class returned by the getTheClass() method
        `attribute` - The name of the attribute to set
        `newValue` - The new value of the attribute

    - #### public void setAttribute(Class sender, Object receiver, String messageName, Object messageValue, boolean useSuper, boolean fromInsideClass)

      Sets the value of an attribute (field). This method is to support the Groovy runtime and not for general client API usage.

      Parameters:
        `sender` - The class of the object that requested the attribute
        `receiver` - The instance
        `messageName` - The name of the attribute
        `messageValue` - The value of the attribute
        `useSuper` - Whether to look-up on the super class or not
        `fromInsideClass` - Whether the call happened from the inside or the outside of a class

    - #### public void setMetaClass(MetaClass metaClass)

      Allows the MetaClass to be replaced with a derived implementation.

      Parameters:
        `metaClass` - the new metaclass

    - #### public void setProperty(Object object, String property, Object newValue)

      Sets a property of an instance of the class returned by the getTheClass() method.

      What this means is largely down to the MetaClass implementation, however the default case would result in an attempt to invoke a JavaBean setter, or if no such setter exists to set a public field of the instance.

      See Also:
        MetaClassImpl
      Parameters:
        `object` - An instance of the class returned by the getTheClass() method
        `property` - The name of the property to set
        `newValue` - The new value of the property

    - #### public void setProperty(Class sender, Object receiver, String messageName, Object messageValue, boolean useSuper, boolean fromInsideClass)

      Sets a property on the given receiver for the specified arguments. The sender is the class that is setting the property from the object. The MetaClass will attempt to establish the method to invoke based on the name and arguments provided.

      The isCallToSuper and fromInsideClass help the Groovy runtime perform optimisations on the call to go directly to the super class if necessary

      Parameters:
        `sender` - The java.lang.Class instance that is mutating the property
        `receiver` - The Object which the property is being set on
        `property` - The name of the property
        `value` - The new value of the property to set
        `isCallToSuper` - Whether the call is to a super class property
        `fromInsideClass` - Whether the call was invoked from the inside or the outside of the class

    - #### public void setProperty(String property, Object newValue)

      Sets the given property to the new value.

      Parameters:
        `propertyName` - the name of the property of interest
        `newValue` - the new value for the property

    - #### public String toString()

      {@inheritDoc}